/*
 * zegar2.c
 *
 * Created: 2011-12-10 20:05:52
 *  Author: Dominik
 */ 
#define SEG_A (1<<PD0)
#define SEG_B (1<<PD1)
#define SEG_C (1<<PD2)
#define SEG_D (1<<PD3)
#define SEG_E (1<<PD4)
#define SEG_F (1<<PD5)
#define SEG_G (1<<PD6)
#define SEG_DP (1<<PD7)
#define PRZYCISK (!(PINC & (1<<PC0)))
#define PRZYCISK2 (!(PINC & (1<<PC1)))
#define WLACZ (1<<PC5)
#define BIJ (1<<PC4)
#include <avr/io.h>
#define F_CPU 3579500
#define SEK 55929
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/eeprom.h>
volatile int sekundy = 0;
volatile int minuty = 0;
volatile int godziny = 0;
volatile int cy1 = 0;
volatile int cy2 = 0;
volatile int cy3 = 0;
volatile int cy4 = 0;
uint8_t popsekundy = 0;
uint8_t popgodziny = 0;
uint8_t tryb = 0;
uint8_t licznik_p = 0;
uint8_t godzina_u = 0;
struct {
	uint8_t k1;
	uint8_t k2;
	uint8_t k3;
	uint8_t k4;
} kropki;
uint8_t liczby[]={
	~(SEG_A|SEG_B|SEG_C|SEG_D|SEG_E|SEG_F),
	~(SEG_B|SEG_C),
	~(SEG_A|SEG_B|SEG_G|SEG_E|SEG_D),
	~(SEG_A|SEG_B|SEG_G|SEG_C|SEG_D),
	~(SEG_F|SEG_G|SEG_B|SEG_C),
	~(SEG_A|SEG_F|SEG_G|SEG_C|SEG_D),
	~(SEG_A|SEG_F|SEG_E|SEG_D|SEG_C|SEG_G),
	~(SEG_A|SEG_B|SEG_C),
	~(SEG_A|SEG_B|SEG_C|SEG_D|SEG_E|SEG_F|SEG_G),
	~(SEG_A|SEG_B|SEG_G|SEG_F|SEG_C|SEG_D),
	~(SEG_A|SEG_B|SEG_G|SEG_F|SEG_E)
};
uint8_t bicie_p = 0;
uint8_t bicie_k = 0;
uint8_t korekta_w = 0;
int8_t korekta = 0;
uint8_t EEMEM ee_bicie_p;
uint8_t EEMEM ee_bicie_k;
uint8_t EEMEM ee_korekta_w;
volatile uint8_t bicie;
int main(void)
{
	bicie_p = eeprom_read_byte(&ee_bicie_p);
	bicie_k = eeprom_read_byte(&ee_bicie_k);
	korekta_w = eeprom_read_byte(&ee_korekta_w);

	if(bicie_p == 255){
		bicie_p = 3;
		bicie_k = 2;
	}
	if(korekta_w == 255){
		korekta_w = 30;
	}
	korekta = (korekta_w/10)-3;
	DDRB |= (1<<PB0) | (1<<PB2) | (1<<PB3) | (1<<PB4) | (1<<PB5);
	DDRD = 0xFF;
	PORTC |= (1<<PC0)|(1<<PC1);
	//ustawienie licznika1
	TCCR1B |= (1<<WGM12);//tryb CTC
	TCCR1B |= (1<<CS10) | (1<<CS11); //preskaler 64
	OCR1A = SEK + korekta;
	TIMSK |= (1<<OCIE1A);
	//ustawienie licznika0
	TCCR0 |= (1<<CS01)|(1<<CS00);//preskaler 64
	
	TIMSK |= (1<<TOIE0);
	TIMSK |= (1<<TOIE2);
	sei();
    while(1)
    {
		poczatek:
		if (tryb == 0){
			while(popsekundy == sekundy){
				if(PRZYCISK){
				tryb = 1;
				goto poczatek;
				}
			}
			if(popgodziny != godziny){
				popgodziny = godziny;
				if(
					(((bicie_k>=bicie_p) && (godziny>=bicie_p && godziny<=bicie_k)) || 
					((bicie_k<bicie_p) && (godziny>=bicie_p || godziny <= bicie_k)))
					&& (bicie_p != 1 || bicie_k != 1)
				){
					if(godziny>12){
						bicie = godziny-12;
					}
					if(godziny==0){
						bicie = 12;
					}
					if(godziny>0 && godziny<13) {
						bicie = godziny;
					}
					TCCR2 |= (1<<CS20) | (1<<CS22);
					
				}
				
			}
			PORTB &= ~(1<<PB0);
			popsekundy = sekundy;
			cy1 = godziny/10;
			cy2 = godziny%10;
			cy3 = minuty/10;
			cy4 = minuty%10;
			for(int i = 0;i<50;i++){
				if(PRZYCISK){
				tryb = 1;
				goto poczatek;
				}
				_delay_ms(10);
			}			
			PORTB |= (1<<PB0);
		}
		if (tryb == 1){
			while(PRZYCISK){
				_delay_ms(100);
				licznik_p++;
				if (licznik_p>20){
					break;
				}
			}
			if(licznik_p < 20){
				tryb = 3;
			}
			else{
				tryb = 4;
			}
			licznik_p = 0;
		}
		if (tryb==3){
			godzina_u = godziny;
			kropki.k4 = 1;
			while(!PRZYCISK){
				if(PRZYCISK2){
					cy4++;
					if(cy4>9){cy4=0;}
					while(PRZYCISK2){}
				}
			}
			while(PRZYCISK){
				
			}
			kropki.k4 = 0;
			kropki.k3 = 1;
			while(!PRZYCISK){
				if(PRZYCISK2){
					cy3++;
					if(cy3>5){cy3=0;}
					while(PRZYCISK2){}
				}
			}
			while(PRZYCISK){
				
			}
			kropki.k3 = 0;
			kropki.k2 = 1;
			kropki.k1 = 1;
			while(!PRZYCISK){
				if(PRZYCISK2){
					godzina_u++;
					if(godzina_u>23){godzina_u=0;}
					cy1 = godzina_u/10;
					cy2 = godzina_u%10;
					while(PRZYCISK2){}
				}
			}
			while(PRZYCISK){
				
			}
			kropki.k2 = 0;
			kropki.k1 = 0;
			godziny = godzina_u;
			popgodziny = godziny;
			minuty = (10*cy3)+cy4;
			sekundy = 0;
			tryb = 0;
		}
		if(tryb == 4){
			cy1 = 10;
			cy2 = 1;
			while(PRZYCISK){
				
			}
			while(!PRZYCISK){
				cy1 = 10;
				cy2 = 1;
				cy3 = bicie_p/10;
				cy4 = bicie_p%10;
				if(PRZYCISK2){
					bicie_p++;
					if(bicie_p>23){bicie_p = 0;}
					cy3 = bicie_p/10;
					cy4 = bicie_p%10;
					while(PRZYCISK2){}
				}
			}
			while(PRZYCISK){
				
			}
			while(!PRZYCISK){
				cy1 = 10;
				cy2 = 2;
				cy3 = bicie_k/10;
				cy4 = bicie_k%10;
				if(PRZYCISK2){
					bicie_k++;
					if(bicie_k>23){bicie_k = 0;}
					cy3 = bicie_k/10;
					cy4 = bicie_k%10;
					while(PRZYCISK2){}
				}
			}
			while(PRZYCISK){
				
			}
			while(!PRZYCISK){
				cy1 = 10;
				cy2 = 3;
				cy3 = korekta_w/10;
				cy4 = korekta_w%10;
				if(PRZYCISK2){
					korekta_w++;
					if(korekta_w>60){korekta_w = 0;}
					cy3 = korekta_w/10;
					cy4 = korekta_w%10;
					while(PRZYCISK2){}
				}
			}
			while(PRZYCISK){
				
			}
			eeprom_write_byte(&ee_bicie_p,bicie_p);
			eeprom_write_byte(&ee_bicie_k,bicie_k);
			eeprom_write_byte(&ee_korekta_w,korekta_w);
			korekta = (korekta_w/10)-3;
			tryb = 0;
		}
		
												
    }
}
ISR(TIMER1_COMPA_vect){
	sekundy++;
	if(sekundy > 59){
		minuty++;
		sekundy = 0;
	}
	if(minuty > 59){
		godziny++;
		minuty = 0;
	}
	if(godziny > 23){
		godziny = 0;
	}
	if(minuty%10 < korekta_w%10){
		OCR1A = SEK + korekta + 1;
	}
	else{
		OCR1A = SEK + korekta;
	}
}
ISR(TIMER0_OVF_vect){
	static uint8_t anody = 0;
	TCNT0 = 128;
	switch (anody){
		case 0:
		PORTB |= (1<<PB2);
		PORTB &= ~(1<<PB3 | 1<<PB4 | 1<<PB5);
		PORTD = liczby[cy1];
		if(kropki.k1){PORTD &= ~SEG_DP;}
		break;
		case 1:
		PORTB |= (1<<PB3);
		PORTB &= ~(1<<PB2 | 1<<PB4 | 1<<PB5);
		PORTD = liczby[cy2];
		if(kropki.k2){PORTD &= ~SEG_DP;}
		break;
		case 2:
		PORTB |= (1<<PB4);
		PORTB &= ~(1<<PB3 | 1<<PB2 | 1<<PB5);
		PORTD = liczby[cy3];
		if(kropki.k3){PORTD &= ~SEG_DP;}
		break;
		case 3:
		PORTB |= (1<<PB5);
		PORTB &= ~(1<<PB3 | 1<<PB4 | 1<<PB2);
		PORTD = liczby[cy4];
		if(kropki.k4){PORTD &= ~SEG_DP;}
		break;
	}
	anody++;
	if (anody>3){
		anody = 0;
	}
	
}
ISR(TIMER2_OVF_vect){
	static int licznik = 0;
	licznik++;
	switch (licznik){
		case 1:
		PORTC |= WLACZ;
		break;
		case 30:
		PORTC |= BIJ;
		break;
		case 40:
		PORTC &= ~BIJ;
		break;
		case 160:
		bicie--;
		if(bicie>0){
			licznik = 1;
		}
		break;
		case 450:
		PORTC &= ~WLACZ;
		licznik = 0;
		TCCR2 &= ~((1<<CS20) | (1<<CS22));
		break;
	}
}	